<?php

if( ! class_exists('Ph_Direct_Booking_Admin_Page') ) {
	class Ph_Direct_Booking_Admin_Page {

		public function __construct() {
			if( isset($_POST['ph_direct_booking_settings']) )
			{
				$this->save_settings();
			}
			$this->init();
		}

		public function init() {
			
			add_action(	'admin_menu', array( $this, 'ph_booking_admin_submenu' ), 11 );
		}

		/**
		 * Add SubMenu to Bookings Menu.
		 */
		public function ph_booking_admin_submenu() {
			add_submenu_page(
				"bookings",
				"Skip Checkout for Bookings",
				__("Skip Checkout",'bookings-and-appointments-for-woocommerce'),
				"manage_options",
				"skip-cart-checkout", 
				array( $this, "output" )
			);
		}

		/**
		 * Settings Page
		 */
		public function output(){
			include 'ph-settings-html.php';
		}

		/**
		 * Save Settings
		 */
		public function save_settings() {
			
			$settings['redirect_url_type']=isset($_POST['redirect_url_type'])?$_POST['redirect_url_type']:'';
			$settings['redirect_url'] = isset($_POST['redirect_url'])?$_POST['redirect_url']:'';
			update_option( PH_BOOKING_DIRECT_BOOKING_SETTING_ID, $settings );
		}

	}
}

new Ph_Direct_Booking_Admin_Page();