<?php

if( ! class_exists('Ph_Direct_Booking_Product_page') ) {
	class Ph_Direct_Booking_Product_page {

		public function __construct() {
			
			// add_filter('woocommerce_add_to_cart_redirect',array($this,'redirect_to_checkout'));
			add_action('woocommerce_add_to_cart',array($this,'redirect_to_checkout'),13,6);
		}

		public function redirect_to_checkout($cart_item_key, $product_id, $quantity, $variation_id, $variation, $cart_item_data){

			// return $cart_item_key;
		   $product_id          = isset($_REQUEST['add-to-cart']) && !empty($_REQUEST['add-to-cart']) ? $_REQUEST['add-to-cart'] : '' ;
			$product      = wc_get_product( $product_id );

			if ( ! $product ) {
				return;
			}
		    $args = array(
		        'status'        => 'processing',
		        'customer_id'   =>  get_current_user_id()
		    );
		    $customer_id = get_current_user_id();
			$cart_item['product_id'] = $product_id;
		    if(isset($cart_item_data['phive_book_from_date']))
		    {

				$buffer_before		 = get_post_meta( $product_id, "_phive_buffer_before", 1 );
				$buffer_after 		 = get_post_meta( $product_id, "_phive_buffer_after", 1 );
				$book_interval 		 = get_post_meta( $product_id, "_phive_book_interval", 1 );
				$buffer_period 		 = get_post_meta( $product_id, "_phive_buffer_period", 1 );
				$enable_buffer		 = get_post_meta( $product_id, '_phive_enable_buffer', 1);
				$persons_as_booking  = get_post_meta( $product_id, "_phive_booking_persons_as_booking", 1 );
				$interval 			 = get_post_meta( $product_id, "_phive_book_interval", 1 );
				$interval_period				= get_post_meta( $product_id, '_phive_book_interval_period', 1 );


				$booking_cost 		 = $_REQUEST['phive_booked_price'];

				$order = new WC_Order();
				$order->set_customer_id( $customer_id );
				$order->set_total( $booking_cost  );
				$order_id = $order->save();
				$order->update_status( 'processing' );

				if ( $order_id ) {

					$item_id  = wc_add_order_item( $order_id, array(
						'order_item_name' => $product->get_title(),
						'order_item_type' => 'line_item',
					) );

						
						$order = wc_get_order( $order_id );
						
						

						$address = array();
						if ( ! empty( $customer_id ) ) {

							$keys  = array(
								'first_name',
								'email'
							);

							$types = array( 'shipping', 'billing' );


							foreach ( $keys as $key ) 
							{
								$address[ $key ] = (string) get_user_meta( $customer_id,   'billing_' . $key, true );

							}
						}
						if(isset($cart_item_data['ph-addons']) && !empty($cart_item_data['ph-addons']))
						{
							foreach ($cart_item_data['ph-addons'] as $key => $addon) {
								if($addon['type']=='textbox' && (strpos($addon['label'], 'Name') !== false || strpos($addon['label'], 'Name') !== false))
								{
									$address['first_name'] = $addon['value'];
								}
								else if($addon['type']=='textbox' && (strpos($addon['label'], 'Email') !== false || strpos($addon['label'], 'email') !== false))
								{
									$address['email'] = $addon['value'];
								}
							}
						}
						$order->set_address( $address, 'billing' );

					$values=$cart_item_data;
					
					$product_interval_details = array(
						'interval'			=>	$interval,
						'interval_format'	=>	$interval_period
					);

					wc_add_order_item_meta( $item_id,'_phive_booking_product_interval_details', $product_interval_details );

					if( array_key_exists('phive_booked_persons', $values) ){

						$persons_pricing_rules  = get_post_meta( $product_id, "_phive_booking_persons_pricing_rules", 1 );
						$number_of_persons 		= 0;
						// Looping through the rule and assign the corresponding rule value given by customer
						foreach ($persons_pricing_rules as $key => $rule) {
							
							if( empty($rule) ){
								continue;
							}

							if( !empty($values['phive_booked_persons'][$key]) ){
								$number_of_persons += $values['phive_booked_persons'][$key];
								wc_add_order_item_meta( $item_id,$rule['ph_booking_persons_rule_type'],$values['phive_booked_persons'][$key] );
							}
						
						}
						
						if( !empty($number_of_persons) ){
							wc_add_order_item_meta( $item_id, 'Number of persons',$number_of_persons );
						}

					}
					// Display Additional Notes
					if( array_key_exists('phive_book_additional_notes_text', $values) ){
						
						$addition_notes_label=get_post_meta($product_id,'_phive_additional_notes_label', 1 );
						// Looping through the rule and assign the corresponding rule value given by customer
						

							if( !empty($values['phive_book_additional_notes_text']) ){
								$additional_notes_text = $values['phive_book_additional_notes_text'];
								wc_add_order_item_meta( $item_id,$addition_notes_label,$values['phive_book_additional_notes_text'] );
							}
						
					}

					//Disply resources details with items
					if( array_key_exists('phive_booked_resources', $values) ){
					
						$resources_pricing_rules 							= get_post_meta( $product_id, "_phive_booking_resources_pricing_rules", 1 );
						
						$resources_type 			= get_post_meta( $product_id, "_phive_booking_resources_type", 1 );
						// Looping through the rule and assign the corresponding rule value given by customer
						foreach ($resources_pricing_rules as $key => $rule) {
							
							if( $rule['ph_booking_resources_auto_assign']=='yes' && $resources_type!='single' ){
								continue;
							}
							if($resources_type=='single')
							{
								if($values['phive_booked_resources'] == $rule['ph_booking_resources_name']){
									wc_add_order_item_meta( $item_id,$rule['ph_booking_resources_name'],'yes' );
								}
							}
							else{

								if( isset($values['phive_booked_resources'][$key]) ){
									wc_add_order_item_meta( $item_id,$rule['ph_booking_resources_name'],$values['phive_booked_resources'][$key] );
								}
							}
							
						}
					}

					//Disply Assets details with items
					if( array_key_exists('phive_booked_assets', $values) && !empty($values['phive_booked_assets']) ){
					
						$asset_settings 			= get_option( 'ph_booking_settings_assets', 1 );
						$this->assets_rules 		= $asset_settings['_phive_booking_assets'];
						$asset_label 				= get_post_meta( $product_id,'_phive_booking_assets_label');
						$asset_label 				= empty($asset_label[0]) ? 'Type' : $asset_label[0];
						$asset_name = $this->assets_rules[ $values['phive_booked_assets'] ]['ph_booking_asset_name'];
						wc_add_order_item_meta( $item_id, 'Assets',array($values['phive_booked_assets']) );
						wc_add_order_item_meta( $item_id, $asset_label,$asset_name );
						
						
					}

					//If case of fixed block of time, show only from date
					if(array_key_exists('phive_book_from_date', $values) && $values['phive_book_from_date']==$values['phive_book_to_date']){
						wc_add_order_item_meta( $item_id,'From',array($values['phive_book_from_date']));
						wc_add_order_item_meta( $item_id,__('Booked From','bookings-and-appointments-for-woocommerce'),Ph_Bookings_General_Functions_Class::phive_get_date_in_wp_format($values['phive_book_from_date']) );
						if(array_key_exists('phive_display_time_to', $values) && !empty($values['phive_display_time_to']))
						{
							wc_add_order_item_meta( $item_id,__('Booked To','bookings-and-appointments-for-woocommerce'),$values['phive_display_time_to'] );
						}
					}else{
						if(array_key_exists('phive_book_from_date', $values)){
							wc_add_order_item_meta( $item_id,'From',array($values['phive_book_from_date']));
							wc_add_order_item_meta( $item_id,__('Booked From','bookings-and-appointments-for-woocommerce'),Ph_Bookings_General_Functions_Class::phive_get_date_in_wp_format($values['phive_book_from_date']));
						}

						if(array_key_exists('phive_book_to_date', $values)){
							wc_add_order_item_meta( $item_id,'To',array($values['phive_book_to_date']));
							$phive_booked_to_date=$values['phive_book_to_date'];
							if( ($interval_period == 'minute') || ($interval_period == 'hour') ){
								$phive_booked_to_date =  date( 'Y-m-d H:i', strtotime( "+$interval $interval_period",strtotime($values['phive_book_to_date']) ) );
							}else{//ticket-117345 remove booking of last date if booking per night enabled
								if( $interval_period == 'day' ) {
									$enable_per_night 	= get_post_meta( $product_id, '_phive_book_charge_per_night', true );
									if( $enable_per_night == 'yes' ) {
										$book_to_date = date_create($phive_booked_to_date);
										$book_to_date->modify("-1 days");
										wc_add_order_item_meta($item_id ,'_ph_book_to_date_with_night', array($book_to_date->format('Y-m-d')));
									}
								}
							}
							wc_add_order_item_meta( $item_id,__('Booked To','bookings-and-appointments-for-woocommerce'),Ph_Bookings_General_Functions_Class::phive_get_date_in_wp_format($phive_booked_to_date));
						}
					}

					if(array_key_exists('phive_booked_price', $values)){
						wc_add_order_item_meta( $item_id,'Cost',$values['phive_booked_price']);
					}
					if($persons_as_booking == 'yes'){

						wc_add_order_item_meta( $item_id,'person_as_booking',array('yes') );
					
					}
					
					$required_confirmation = get_post_meta( $cart_item['product_id'], '_phive_book_required_confirmation', 1 );
					
						if( $required_confirmation==='yes' ){
							$is_confirm_required = 'true';
							}
							else{
							$is_confirm_required = 'false';	
							}
					
					if( $required_confirmation== 'true'){
						$booking_status = 'requires-confirmation';
					}else{
						$booking_status = 'un-paid';
					}

					if($enable_buffer=='yes'){	
						$buffer_before_from 		= $this->phive_buffer_before_time($values['phive_book_from_date'],$buffer_period,$book_interval,$buffer_before,$buffer_after);

						$buffer_after_to 			= $this->phive_buffer_after_time($values['phive_book_from_date'],$values['phive_book_to_date'],$buffer_period,$book_interval,$buffer_before,$buffer_after);
						switch($interval_period){
							case 'day':
									$buffer_after_from 	= date ( "Y-m-d", strtotime( "+$interval $interval_period", strtotime($values['phive_book_to_date']) ) );
							
									$buffer_before_to 		= date ( "Y-m-d", strtotime( "-$interval $interval_period", strtotime($values['phive_book_from_date']) ) );
								break;
							 case 'hour':
							 			$buffer_after_from 	= date ( "Y-m-d H:i", strtotime( "+$interval $interval_period", strtotime($values['phive_book_to_date']) ) );
							
										$buffer_before_to 		= date ( "Y-m-d H:i", strtotime( "-$interval $interval_period", strtotime($values['phive_book_from_date']) ) );
							 			break;
							 case 'minute':
							 			$buffer_after_from 	= date ( "Y-m-d H:i", strtotime( "+$interval $interval_period", strtotime($values['phive_book_to_date']) ) );
							
										$buffer_before_to 		= date ( "Y-m-d H:i", strtotime( "-$interval $interval_period", strtotime($values['phive_book_from_date']) ) );
							 			break;
						}
						
						
						if($buffer_before_from == ''){
							$buffer_before_to ='';
						}
						if($buffer_after_to == ''){
							$buffer_after_from = '';
						}	
						if($persons_as_booking == 'yes'){
							$buffer_before_id 					= $this->phive_save_booking_buffer_info($product_id,$buffer_before_from,$buffer_before_to,array('yes'),$number_of_persons,'yes','buffer-before');
							$buffer_after_id 					= $this->phive_save_booking_buffer_info($product_id,$buffer_after_from,$buffer_after_to,array('yes'),$number_of_persons,'yes','buffer-after');
						}
						else{
							$buffer_before_id 					= $this->phive_save_booking_buffer_info($product_id,$buffer_before_from,$buffer_before_to,'','','yes','buffer-after');
							$buffer_after_id 					= $this->phive_save_booking_buffer_info($product_id,$buffer_after_from,$buffer_after_to,'','','yes','buffer-after');
						}
						
						$buffer_before_ids = array("$buffer_before_id");
						$buffer_after_ids = array("$buffer_after_id");
					
						wc_add_order_item_meta($item_id, 'buffer_before_id',$buffer_before_ids );
						wc_add_order_item_meta($item_id, 'buffer_after_id',$buffer_after_ids );
							
					}

					wc_add_order_item_meta( $item_id, '_line_total', $booking_cost );
					wc_add_order_item_meta( $item_id, '_line_subtotal', $booking_cost );
					wc_add_order_item_meta( $item_id, '_qty', 1 );
					wc_add_order_item_meta( $item_id, '_tax_class', $product->get_tax_class() );

					wc_add_order_item_meta( $item_id, '_product_id', $product->get_id() );
					// wc_add_order_item_meta( $item_id, 'booking_status',$booking_status );
					
					wc_update_order_item_meta( $item_id, 'booking_status', array($booking_status) );

					$booking_status_name = array(
						'paid'					=>	__( 'Paid', 'bookings-and-appointments-for-woocommerce' ),
						'un-paid'				=>	__( 'Unpaid', 'bookings-and-appointments-for-woocommerce' ),
						'canceled'				=>	__( 'Cancelled', 'bookings-and-appointments-for-woocommerce' ),
						'requires-confirmation'	=>	__( 'Requires Confirmation', 'bookings-and-appointments-for-woocommerce' )
					);

					wc_update_order_item_meta( $item_id, __('Booking Status','bookings-and-appointments-for-woocommerce'), __( $booking_status_name[$booking_status], 'bookings-and-appointments-for-woocommerce' ) );

					$tax_item_id='';
					
					// add recurrence data to order
					do_action('ph_add_additional_order_item_meta_for_admin_bookings', $item_id, $order_id, $cart_item, $product->get_id(), $tax_item_id, $order);

					do_action('ph_booking_google_calender_sync_for_admin_bookings',$order_id);
					
				}

				WC()->cart->remove_cart_item( $cart_item_key );

				$url = $order->get_view_order_url( ); 
				$settings=get_option(PH_BOOKING_DIRECT_BOOKING_SETTING_ID,false);
				$redirect_url_type=isset($settings['redirect_url_type'])?$settings['redirect_url_type']:'';
				$redirect_url = isset($settings['redirect_url'])?$settings['redirect_url']:'';
				if($redirect_url_type=='custom_page' && !empty($redirect_url))
				{
					$url = $redirect_url;
				}

				wp_safe_redirect( $url );
				exit;
		    }


			// $checkout_url = $order->get_view_order_url();
			return $cart_item_key;
		}
		private function phive_buffer_before_time($from,$buffer_period,$book_interval,$buffer_before,$buffer_after='0'){
		
		
			switch($buffer_period){
				case 'day':
					$buffer_before_time=date('Y-m-d', (strtotime($from) - ($buffer_before*3600*24)));
					break;
				case 'hour':
					$buffer_before_time=date('Y-m-d H:i', (strtotime($from) -( $buffer_before*3600)));
					break;
				case 'minute':
					$buffer_after=isset($buffer_after)?$buffer_after:'00';
					$buffer_before_time=date('Y-m-d H:i', (strtotime($from) -( $buffer_before*60)));
					break;
			}
			return $buffer_before_time;

		}

	private function phive_buffer_after_time($from,$to='',$buffer_period,$book_interval,$buffer_before='0',$buffer_after){
		$to=!empty($to)?$to:$from;
		switch($buffer_period){
				case 'day':
					$buffer_after_time=date('Y-m-d', (strtotime($to) + ($buffer_after*3600*24)));
					break;
				case 'hour':
					$buffer_after_time=date('Y-m-d H:i', (strtotime($to) +($buffer_after*3600 )));
					;
					break;
				case 'minute':
					$buffer_before=isset($buffer_before)?$buffer_before:'00';
					$buffer_after_time=date('Y-m-d H:i', (strtotime($to) +($buffer_after*60 )));
					;
					break;
			}
			return $buffer_after_time;
	}

	private function phive_save_booking_buffer_info($product_id,$buffer_before_time,$buffer_after_time,$person_as_booking='',$number_of_booking='',$is_buffer='',$buffer_type=''){
		$new_post = array(
			'ID' => '',
			'post_type' => 'booking_buffer_freez', // Custom Post Type Slug
			'post_status' => 'open',
			'post_title' => 'Booking buffer freezer',
			'ping_status' => 'closed',
		);

		$buffer_id = wp_insert_post($new_post);
		if( !$buffer_id ){
			return false;
		}
		if($is_buffer == 'yes' && $buffer_type == 'buffer-before'){
			$meta_values = array(
			'_product_id' 			=> $product_id,
			'Buffer_before_From'	=> $buffer_before_time,
			'Buffer_before_To'		=> $buffer_after_time,
			'_booking_customer_id'	=> is_user_logged_in() ? get_current_user_id() : 0,
			'Number of persons' 	=> $number_of_booking,
			'person_as_booking' 	=> $person_as_booking,
			'ph_canceled' 	=> '0',
			
		);
		}elseif($is_buffer == 'yes' && $buffer_type == 'buffer-after'){
			$meta_values = array(
			'_product_id' 			=> $product_id,
			'Buffer_after_From'		=> $buffer_before_time,
			'Buffer_after_To'		=> $buffer_after_time,
			'_booking_customer_id'	=> is_user_logged_in() ? get_current_user_id() : 0,
			'Number of persons' 	=> $number_of_booking,
			'person_as_booking' 	=> $person_as_booking,
			'ph_canceled' 	=> '0',
			
		);
		}
		foreach ( $meta_values as $meta_key => $value ) {
			update_post_meta( $buffer_id, $meta_key, $value );
		}
		
		return $buffer_id;
	}

	}
}

new Ph_Direct_Booking_Product_page();